import { Router } from '@angular/router';
import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSchemaEnum, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ModalHelper, _HttpClient } from '@delon/theme';
import { ShipperBaseService } from '@shared';
import { NzModalService } from 'ng-zorro-antd/modal';
import { of } from 'rxjs';
import { map } from 'rxjs/operators';
import { UpdateFreightComponent } from '../../modal/bulk/update-freight/update-freight.component';
import { OneCarOrderCancelComponent } from '../../modal/vehicle/cancel/cancel.component';
import { VehicleConfirReceiptComponent } from '../../modal/vehicle/confir-receipt/confir-receipt.component';
import { VehicleSureArriveComponent } from '../../modal/vehicle/sure-arrive/sure-arrive.component';
import { VehicleSureDepartComponent } from '../../modal/vehicle/sure-depart/sure-depart.component';
import { VehicleUpdateFreightComponent } from '../../modal/vehicle/update-freight/update-freight.component';
import { OrderManagementService } from '../../services/order-management.service';
import { VehicleModifyRateComponent } from '../../modal/vehicle/modify-rate/modify-rate.component';
import { VehicleFreightPeopleComponent } from '../../modal/vehicle/freight-people/freight-people.component';
import { VehicleModifyCaptainComponent } from '../../modal/vehicle/modify-captain/modify-captain.component';


@Component({
  selector: 'app-supply-management-vehicle',
  templateUrl: './vehicle.component.html',
  styleUrls: ['./vehicle.component.less']
})
export class OrderManagementVehicleComponent implements OnInit {
  ui: SFUISchema = {};
  schema: SFSchema = {};
  auditMany = false;
  isVisibleView = false;
  isVisibleEvaluate = false;
  isVisible = false;
  changeId: any;       // 主页面查看运费变更记录id - 用于运费变更记录
  changeViewId: any;  // 查看运费变更记录id - 用于查看
  ViewCause: any;  // 变更运费查看数据
  _$expand = false;
  @ViewChild('st') private readonly st!: STComponent;
  @ViewChild('stFloat') private readonly stFloat!: STComponent;
  @ViewChild('stFloatView') private readonly stFloatView!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  @ViewChild('sfFre', { static: false }) sfFre!: SFComponent;
  columns: STColumn[] = [];
  columnsFloat: STColumn[] = [];
  columnsFloatView: STColumn[] = [];
  datass: any = [
    {
    one: '1',
    two: '1',
    three: '1',
    id: 1
   },
    {
    one: '2',
    two: '2',
    three: '2',
    id: 2
   },
];
tabs = {
  cancelQuantity: 0,
  receivedQuantity: 0,
  stayQuantity: 0
};
resourceStatus: any;
  constructor(
    public service: OrderManagementService,
    private modal: NzModalService,
    public service2: ShipperBaseService,
    public router: Router,
     ) { }

  /**
 * 查询参数
 */
  get changeParams() {
    return {
      id: this.changeId
    };
  }
  get changeViewParams() {
    return {
      id: this.changeViewId
    };
  }
  get reqParams() {
    const a:any = {};
    if(this.resourceStatus) {
      a.billStatus = this.resourceStatus + 1;
    }
    return {
      ...a,
      ...this.sf?.value,
    };
  }
  get selectedRows() {
    return this.st?.list.filter((item) => item.checked) || [];
  }
  ngOnInit(): void {
    this.getGoodsSourceStatistical()
    this.initSF();
    this.initST();
    this.initSTFloat();
    this.initSTFloatView();
  }

  getGoodsSourceStatistical() {
    this.service.request(this.service.$api_statisticalStatus).subscribe(res => {
      if (res) {
       res.forEach((element: any) => {
        if(element.statusLabel === '待发车') {
          this.tabs.stayQuantity = element.quantity
        } else if (element.statusLabel === '待接单') {
          this.tabs.receivedQuantity = element.quantity
        } else if (element.statusLabel === '待签收') {
          this.tabs.cancelQuantity = element.quantity
        } 
       });
      }
    })
  }

  /**
 * 初始化查询表单
 */
   initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        billCode: {
          type: 'string',
          title: '订单号'
          
        },
        resourceCode: {
          type: 'string',
          title: '货源编号'
        },
        shipperAppUserId: {
          type: 'string',
          title: '货主',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              console.log(q)
              if (!!q) {
                return this.service
                  .request(this.service.$api_enterpriceList, { enterpriseName: q})
                  .pipe(map((res: any) => (res as any[]).map((i) => ({ label: i.enterpriseName, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
          } as SFSelectWidgetSchema,
        },
        loadingPlace: {
          type: 'string',
          title: '装货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        dischargePlace: {
          type: 'string',
          title: '卸货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        driverId: {
          title: '承运司机',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getDriverInfo, { keyword: q, model: 1, type: 1 })
                  .pipe(map(res => (res as any[]).map(i => ({ label: i.name, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },

        carNo: { 
          title: '车牌号',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getCarLicenseListByCarNo, {
                    carNo: q
                  })
                  .pipe(map((res: any[]) => (res as any[]).map((i) => ({ label: i.carNo, value: i.carNo } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
         },
         payeeId: {
          title: '车队长',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getDriverInfo, { keyword: q,
                  model: 1, type: 2 })
                  .pipe(map((res) => (res as any[]).map((i) => ({ label: i.name, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        }, 
        paymentstatus: {
          title: '支付状态',
          type: 'string',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'payment:status' },
            containAllLable:true,
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
        creationTime: {
          title: '创建时间',
          type: 'string',
          ui: {
            widget: 'date',
            mode: 'range',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFDateWidgetSchema
        },
        isRiskSheet: {
          type: 'string',
          title: '是否风险单',
          enum: [
            { label: '全部', value: '' },
            { label: '是', value: '1' },
            { label: '否', value: '2' }
          ],
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          },
        },
        enterpriseInfoId: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
            allowClear: true,
            asyncData: () => this.service2.getNetworkFreightForwarder(),
          },
        },
        goodsName: {
          type: 'string',
          title: '货物名称',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
            allowClear: true,
            asyncData: () => this.getCatalogueMember(),
          },
        },
        serviceType: {
          title: '服务类型',
          type: 'string',
          default: '',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'service:type' },
            containAllLable:true,
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
      },
      type: 'object'
    };
    this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', width: '50px', className: 'text-center' },
      {
        title: '订单号',
        width: '100px',
        className: 'text-center',
        render: 'billCode'
      },
      {
        title: '运费明细',
        width: '200px',
        className: 'text-center',
        render: 'mybidDetailInfo',
      },
      { title: '网络货运人', index: 'enterpriseInfoName', width: '120px', className: 'text-center' },
      { title: '货主', index: 'shipperAppUserName', width: '120px', className: 'text-center' },
      { title: '关联运单号', index: 'wayBillCode', width: '120px', className: 'text-center' },
      { title: '货源编号', index: 'resourceCode', width: '120px', className: 'text-center' },
      { title: '装货地', index: 'loadingAddressArr', width: '120px', className: 'text-center' },
      {
        title: '卸货地',
        className: 'text-center',
        width: '120px',
        index: 'unloadingAddressArr'
      },
      {
        title: '货物信息',
        className: 'text-center',
        width: '120px',
        render: 'goodsName'
      }, {
        title: '承运司机',
        className: 'text-center',
        width: '120px',
        render: 'driverName'
      },
      {
        title: '收款人',
        className: 'text-center',
        render: 'payeeName',
        width: '100px',
      },
      {
        title: '装卸货时间',
        width: '170px',
        className: 'text-center',
        render: 'loadingTime'
      },
      {
        title: '创建时间',
        className: 'text-center',
        index: 'creationTime',
      },
      {
        title: '操作',
        fixed: 'right',
        width: '200px',
        className: 'text-left',
        buttons: [
          {
            text: '查看评价',
            click: (_record) => this.viewEvaluate(_record),
            iif: item => item.billStatus == '5',
          },
          {
            text: '运费变更记录',
            click: (_record) => this.OpenPrice(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3' || item.billStatus == '6', 
          },
          {
            text: '变更运费',
            click: (_record) => this.updateFreight(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3',
          },
          {
            text: '确认签收',
            click: (_record) => this.confirmReceipt(_record),
            iif: item => item.billStatus == '4',
          },
          {
            text: '取消订单',
            click: (_record) => this.cancellation(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3' || item.billStatus == '1',
          },
          {
            text: '修改订单',
            click: (_record) => this.changeOrder(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3',
          },
          {
            text: '查看轨迹',
            click: (_record) => this.cancellation(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3',
          },
          
        ],
      },
    ];
  }
  initSTFloat() {
    this.columnsFloat = [
      {
        title: '序号',
        className: 'text-center',
        render: 'order'
      },
      {
        title: '操作时间',
        className: 'text-center',
        index: 'applyTime'
      },
      {
        title: '操作人',
        className: 'text-center',
        index: 'applyUserName'
      },
      { title: '状态',     index: 'handleStatus',  className: 'text-center' },
      {
        title: '操作',
        fixed: 'right',
        className: 'text-left',
        buttons: [
          {
            text: '查看',
            click: (_record) => this.FloatView(_record),
          },
          // {
          //   text: '查看协议',
          //   click: (_record, _modal, _instance) => this.view(_record)
          // },
          {
            text: '撤销',
            click: (_record) => this.revoke(_record),
           iif: item => item.handleStatus === '1' || item.handleStatus === 1,
          },
        ],
      },
    ];
  }
  initSTFloatView() {
    this.columnsFloatView = [
      {
        title: '费用名称',
        width: '100px',
        className: 'text-center',
        index: 'costName'
      },
      {
        title: '变更前',
        width: '100px',
        className: 'text-center',
        index: 'amountAfterChange'
      },
      { title: '变更值', index: 'amountchangeValue', width: '120px', className: 'text-center' },
      { title: '变更后', index: 'amountBeforeChange', width: '120px', className: 'text-center' }
    ];
  }
  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }
  /**
  * 伸缩查询条件
  */
  expandToggle(): void {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }
  tabChange(item: any) {
    console.log(item)
  }
  /**
   * 重置表单
   */
  resetSF(): void {
    this.sf.reset();
    this._$expand = false;
  }



  // 获取录单员 
  getCatalogueMember() {
    const params = {
    };
    return this.service.request(this.service.$api_get_catalogue_member, params, 'GET').pipe(
      map((res) => {
        if (res) {
          console.log(res)
        }
      }),
    );
  }

  selectChange(e: number) {
    console.log(e);
    this.resourceStatus = e;
    this.initST();
    setTimeout(() => {
      this.st.load();
    }, 500);
  }
  /**
   * 导入货源
   */
  importGoodsSource() {

  }
  audit(item: any) {
    console.log(item)
  }

 /*
  * 审核关闭弹窗
  view: 1
  浮动费用： 0
  查看评价： 3
  */
  handleCancel(type: string) {
    console.log(type)
    if(type === '0') {
      this.isVisible = false
    } else if(type === '1') {
    console.log(type)
      this.isVisibleView = false
    } else if(type === '2') {
    console.log(type)
      this.isVisibleEvaluate = false
    }
  }
    /**
  * 审核通过按钮
  */
  handleOK() {
    
  }
  OpenPrice(value: any) {
    console.log(value)
    this.changeId = value.id;
    this.isVisible = true
  }
   /**
  * 浮动费用查看
  */
  FloatView(item: any) {
    console.log(item)
    this.changeViewId = item.id;
    this.service.request(this.service.$api_getChangeRecordWholeDetail, {id: this.changeViewId}).subscribe((res) => {
      this.ViewCause = res;
    })
    this.isVisibleView = true
  }
   /**
  *查看评价
  */
  viewEvaluate(item: any) {
    console.log(item)
    this.isVisibleEvaluate = true
  }
      /**
   *变更运费
   */
   updateFreight(item: any) {
    this.service.request(this.service.$api_get_getFreightChangeWholeDetail, { id: item.id }).subscribe(data => {
      if (data) {
        const modal = this.modal.create({
          nzTitle: '变更运费',
          nzWidth: 580,
          nzContent: VehicleUpdateFreightComponent,
          nzComponentParams: { data: { ...data, id: item.id } },
          nzFooter: null,
          // nzOnOk: sin => {
          //   this.service.request(this.service.$api_change_bulk, { billId: item.id, ...sin.sf.value }).subscribe(res => {
          //     if (res) {
          //       this.service.msgSrv.success('变更运费成功');
          //       modal.destroy();
          //       this.st.reload();
          //     }
          //   });
          //   return false;
          // }
        });
        modal.afterClose.subscribe(_ => this.st.reload());
      }
    });
  }
  /**
   *修改附加费率
   */
   modifyRate() {
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    if(params.length  === 0) {
      this.service.msgSrv.error('请先选择订单！')
      return
    }
        const modal = this.modal.create({
          nzTitle: '修改附加费率',
          nzWidth: 600,
          nzContent: VehicleModifyRateComponent,
          nzComponentParams: { data: { ids: params } },
          nzFooter: null,
        });
        modal.afterClose.subscribe((result) => {
          if (result) {
            this.st.load(1);
          }
        });
  }
      /**
   *修改网络货运人
   */
   modifyFreightPeople() {
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    let params2: any[] = [];
    this.selectedRows.forEach(item => {
      params2.push(item.enterpriseInfoId);
    });
    if(params.length  === 0) {
      this.service.msgSrv.error('请先选择订单！')
      return
    }
        const modal = this.modal.create({
          nzTitle: '修改网络货运人',
          nzWidth: 600,
          nzContent: VehicleFreightPeopleComponent,
          nzComponentParams: { data: { ids: params, enterpriseInfoIds: params2, } },
          nzFooter: null,
          // nzOnOk: sin => {
          //   this.service.request(this.service.$api_change_bulk, { billId: item.id, ...sin.sf.value }).subscribe(res => {
          //     if (res) {
          //       this.service.msgSrv.success('变更运费成功');
          //       modal.destroy();
          //       this.st.reload();
          //     }
          //   });
          //   return false;
          // }
        });
  }
      /**
   *修改网络货运人
   */
   modifycaptain() {
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    if(params.length  === 0) {
      this.service.msgSrv.error('请先选择订单！')
      return
    }
        const modal = this.modal.create({
          nzTitle: '修改车队长',
          nzWidth: 900,
          nzContent: VehicleModifyCaptainComponent,
          nzComponentParams: { data: { ids: params,  } },
          nzFooter: null,
          // nzOnOk: sin => {
          //   this.service.request(this.service.$api_change_bulk, { billId: item.id, ...sin.sf.value }).subscribe(res => {
          //     if (res) {
          //       this.service.msgSrv.success('变更运费成功');
          //       modal.destroy();
          //       this.st.reload();
          //     }
          //   });
          //   return false;
          // }
        });
  }
  
  //  *确认签收
   
  confirmReceipt(item: any) {
    const modalRef = this.modal.create({
      nzTitle: '确认签收',
      nzWidth: '50%',
      nzContent: VehicleConfirReceiptComponent,
      nzComponentParams: {
        i: item,
        Status: 2
      },
      nzFooter: null
    });
  }
    revoke(item: any) {
      this.modal.confirm({
        nzTitle: '是否确定立即撤销费用变更！</i>',
        nzOnOk: () => 
        this.service.request(this.service.$api_get_revokeChangeRecord, { id: item.id}).subscribe((res) => {
          console.log(res)
          if(res) {
            this.service.msgSrv.success('撤销成功！')
            this.stFloat.reload()
          } else {
            this.service.msgSrv.error(res.msg)
          }
        })
      });
    }
    // 取消订单
    cancellation(item: any) {
      // api_get_cancelAnOrder
      this.modal.confirm({
        nzTitle: '<b>确定取消该订单吗?</b>',
        nzContent: `<b>取消后无法恢复，请确认</b>`,
        nzOnOk: () =>
          this.service.request(this.service.$api_get_cancelAnOrder, {id: item.id}).subscribe((res) => {
            if (res === true) {
              this.service.msgSrv.success('操作成功！');
              this.st?.reload();
              this.initST();
            }
          }),
      })
    }
    userAction() {
      let params: any[] = [];
      this.selectedRows.forEach(item => {
        params.push(item.id);
      });
      if(params.length  === 0) {
        this.service.msgSrv.error('请先选择订单！')
        return
      }
      this.service.request(this.service.$api_get_batchSignWholeOrder, params).subscribe(res => {
        if (res) {
          console.log(res);
        } else {
          this.service.msgSrv.error(res.msg);
        }
      });
    }
      // 修改订单
  changeOrder(value: any) {
    this.router.navigate(['order-management/vehicle-detailChange', value.id]);
  }
}
